Index: LMDZ5/branches/testing/libf/phydev/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 1669)
+++ LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 1707)
@@ -11,114 +11,145 @@
      &            , PVteta)
 
-      USE dimphy
-      USE infotrac
-      USE comgeomphy
+      USE dimphy, only : klon,klev
+      USE infotrac, only : nqtot
+      USE comgeomphy, only : rlatd
+      USE comcstphy, only : rg
+      USE iophy, only : histbeg_phy,histwrite_phy
+      USE ioipsl, only : getin,histvert,histdef,histend,ymds2ju
+      USE mod_phys_lmdz_para, only : jj_nb
+      USE phys_state_var_mod, only : phys_state_var_init
 
       IMPLICIT none
-!======================================================================
-! Objet: Moniteur general de la physique du modele
-!======================================================================
+#include "dimensions.h"
+
+      integer,parameter :: jjmp1=jjm+1-1/jjm
+      integer,parameter :: iip1=iim+1
 !
-!  Arguments:
+! Routine argument:
 !
-! nlon----input-I-nombre de points horizontaux
-! nlev----input-I-nombre de couches verticales, doit etre egale a klev
-! debut---input-L-variable logique indiquant le premier passage
-! lafin---input-L-variable logique indiquant le dernier passage
-! jD_cur       -R-jour courant a l'appel de la physique (jour julien)
-! jH_cur       -R-heure courante a l'appel de la physique (jour julien)
-! pdtphys-input-R-pas d'integration pour la physique (seconde)
-! paprs---input-R-pression pour chaque inter-couche (en Pa)
-! pplay---input-R-pression pour le mileu de chaque couche (en Pa)
-! pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
-! pphis---input-R-geopotentiel du sol
-! presnivs-input_R_pressions approximat. des milieux couches ( en PA)
-! u-------input-R-vitesse dans la direction X (de O a E) en m/s
-! v-------input-R-vitesse Y (de S a N) en m/s
-! t-------input-R-temperature (K)
-! qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
-! d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
-! d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
-! flxmass_w -input-R- flux de masse verticale
-! d_u-----output-R-tendance physique de "u" (m/s/s)
-! d_v-----output-R-tendance physique de "v" (m/s/s)
-! d_t-----output-R-tendance physique de "t" (K/s)
-! d_qx----output-R-tendance physique de "qx" (kg/kg/s)
-! d_ps----output-R-tendance physique de la pression au sol
-!IM
-! PVteta--output-R-vorticite potentielle a des thetas constantes
-!======================================================================
-#include "dimensions.h"
-#include "comcstphy.h"
+      integer,intent(in) :: nlon ! number of atmospheric colums
+      integer,intent(in) :: nlev ! number of vertical levels (should be =klev)
+      real,intent(in) :: jD_cur ! current day number (Julian day)
+      real,intent(in) :: jH_cur ! current time of day (as fraction of day)
+      logical,intent(in) :: debut ! signals first call to physics
+      logical,intent(in) :: lafin ! signals last call to physics
+      real,intent(in) :: pdtphys ! physics time step (s)
+      real,intent(in) :: paprs(klon,klev+1) ! interlayer pressure (Pa)
+      real,intent(in) :: pplay(klon,klev) ! mid-layer pressure (Pa)
+      real,intent(in) :: pphi(klon,klev) ! geopotential at mid-layer
+      real,intent(in) :: pphis(klon) ! surface geopotential
+      real,intent(in) :: presnivs(klev) ! pseudo-pressure (Pa) of mid-layers
+      integer,parameter :: longcles=20
+      real,intent(in) :: clesphy0(longcles) ! Not used
+      real,intent(in) :: u(klon,klev) ! eastward zonal wind (m/s)
+      real,intent(in) :: v(klon,klev) ! northward meridional wind (m/s)
+      real,intent(in) :: t(klon,klev) ! temperature (K)
+      real,intent(in) :: qx(klon,klev,nqtot) ! tracers (.../kg_air)
+      real,intent(in) :: flxmass_w(klon,klev) ! vertical mass flux
+      real,intent(out) :: d_u(klon,klev) ! physics tendency on u (m/s/s)
+      real,intent(out) :: d_v(klon,klev) ! physics tendency on v (m/s/s)
+      real,intent(out) :: d_t(klon,klev) ! physics tendency on t (K/s)
+      real,intent(out) :: d_qx(klon,klev,nqtot) ! physics tendency on tracers
+      real,intent(out) :: d_ps(klon) ! physics tendency on surface pressure
+      real,intent(in) :: dudyn(iim+1,jjmp1,klev) ! Not used
+!FH! REAL PVteta(klon,nbteta)
+!      REAL PVteta(klon,1)
+      real,intent(in) :: PVteta(klon,3) ! Not used ; should match definition
+                                        ! in calfis.F
 
-      integer jjmp1
-      parameter (jjmp1=jjm+1-1/jjm)
-      integer iip1
-      parameter (iip1=iim+1)
+integer,save :: itau=0 ! counter to count number of calls to physics
+!$OMP THREADPRIVATE(itau)
+real :: temp_newton(klon,klev)
+integer :: k
+logical, save :: first=.true.
+!$OMP THREADPRIVATE(first)
 
-      INTEGER ivap          ! indice de traceurs pour vapeur d'eau
-      PARAMETER (ivap=1)
-      INTEGER iliq          ! indice de traceurs pour eau liquide
-      PARAMETER (iliq=2)
+! For I/Os
+integer :: itau0
+real :: zjulian
+real :: dtime
+integer :: nhori ! horizontal coordinate ID
+integer,save :: nid_hist ! output file ID
+!$OMP THREADPRIVATE(nid_hist)
+integer :: zvertid ! vertical coordinate ID
+integer,save :: iwrite_phys ! output every iwrite_phys physics step
+!$OMP THREADPRIVATE(iwrite_phys)
+real :: t_ops ! frequency of the IOIPSL operations (eg average over...)
+real :: t_wrt ! frequency of the IOIPSL outputs
 
-!
-!
-! Variables argument:
-!
-      INTEGER nlon
-      INTEGER nlev
-      REAL, intent(in):: jD_cur, jH_cur
+! initializations
+if (debut) then ! Things to do only for the first call to physics 
+! load initial conditions for physics (including the grid)
+  call phys_state_var_init() ! some initializations, required before calling phyetat0
+  call phyetat0("startphy.nc")
 
-      REAL pdtphys
-      LOGICAL debut, lafin
-      REAL paprs(klon,klev+1)
-      REAL pplay(klon,klev)
-      REAL pphi(klon,klev)
-      REAL pphis(klon)
-      REAL presnivs(klev)
-      REAL znivsig(klev)
-      real pir
+! Initialize outputs:
+  itau0=0
+  iwrite_phys=1 !default: output every physics timestep
+  call getin("iwrite_phys",iwrite_phys)
+  t_ops=pdtphys*iwrite_phys ! frequency of the IOIPSL operation
+  t_wrt=pdtphys*iwrite_phys ! frequency of the outputs in the file
+  ! compute zjulian for annee0=1979 and month=1 dayref=1 and hour=0.0
+  !CALL ymds2ju(annee0, month, dayref, hour, zjulian)
+  call ymds2ju(1979, 1, 1, 0.0, zjulian)
+  dtime=pdtphys
+  call histbeg_phy("histins.nc",itau0,zjulian,dtime,nhori,nid_hist)
+!$OMP MASTER
+  ! define vertical coordinate
+  call histvert(nid_hist,"presnivs","Vertical levels","Pa",klev, &
+                presnivs,zvertid,'down')
+  ! define variables which will be written in "histins.nc" file
+  call histdef(nid_hist,'temperature','Atmospheric temperature','K', &
+               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               'inst(X)',t_ops,t_wrt)
+  call histdef(nid_hist,'u','Eastward Zonal Wind','m/s', &
+               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               'inst(X)',t_ops,t_wrt)
+  call histdef(nid_hist,'v','Northward Meridional Wind','m/s', &
+               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               'inst(X)',t_ops,t_wrt)
+  call histdef(nid_hist,'ps','Surface Pressure','Pa', &
+               iim,jj_nb,nhori,1,1,1,zvertid,32, &
+               'inst(X)',t_ops,t_wrt)
+  ! end definition sequence
+  call histend(nid_hist)
+!$OMP END MASTER
+endif ! of if (debut)
 
-      REAL u(klon,klev)
-      REAL v(klon,klev)
-      REAL t(klon,klev),theta(klon,klev)
-      REAL qx(klon,klev,nqtot)
-      REAL flxmass_w(klon,klev)
-      REAL omega(klon,klev) ! vitesse verticale en Pa/s
-      REAL d_u(klon,klev)
-      REAL d_v(klon,klev)
-      REAL d_t(klon,klev)
-      REAL d_qx(klon,klev,nqtot)
-      REAL d_ps(klon)
-      real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
-!IM definition dynamique o_trac dans phys_output_open
-!      type(ctrl_out) :: o_trac(nqtot)
-!FH! REAL PVteta(klon,nbteta)
-      REAL PVteta(klon,1)
-      REAL dudyn(iim+1,jjmp1,klev)
+! increment counter itau
+itau=itau+1
 
-    INTEGER        longcles
-    PARAMETER    ( longcles = 20 )
+! set all tendencies to zero
+d_u(1:klon,1:klev)=0.
+d_v(1:klon,1:klev)=0.
+d_t(1:klon,1:klev)=0.
+d_qx(1:klon,1:klev,1:nqtot)=0.
+d_ps(1:klon)=0.
 
-real temp_newton(klon,klev)
-integer k
-logical, save :: first=.true.
-
-      REAL clesphy0( longcles      )
-
-d_u=0.
-d_v=0.
-d_t=0.
-d_qx=0.
-d_ps=0.
-
-     d_u(:,1)=-u(:,1)/86400.
-     do k=1,klev
-        temp_newton(:,k)=280.+cos(rlatd(:))*40.-pphi(:,k)/rg*6.e-3
-        d_t(:,k)=(temp_newton(:,k)-t(:,k))/1.e5
-     enddo
+! compute tendencies to return to the dynamics:
+! "friction" on the first layer
+d_u(1:klon,1)=-u(1:klon,1)/86400.
+d_v(1:klon,1)=-v(1:klon,1)/86400.
+! newtonian relaxation towards temp_newton()
+do k=1,klev
+  temp_newton(1:klon,k)=280.+cos(rlatd(1:klon))*40.-pphi(1:klon,k)/rg*6.e-3
+  d_t(1:klon,k)=(temp_newton(1:klon,k)-t(1:klon,k))/1.e5
+enddo
 
 
-      print*,'COUCOU PHYDEV'
-      return
-      end
+!print*,'PHYDEV: itau=',itau
+
+! write some outputs:
+if (modulo(itau,iwrite_phys)==0) then
+  call histwrite_phy(nid_hist,.false.,"temperature",itau,t)
+  call histwrite_phy(nid_hist,.false.,"u",itau,u)
+  call histwrite_phy(nid_hist,.false.,"v",itau,v)
+  call histwrite_phy(nid_hist,.false.,"ps",itau,paprs(:,1))
+endif
+
+! if lastcall, then it is time to write "restartphy.nc" file
+if (lafin) then
+  call phyredem("restartphy.nc")
+endif
+
+end
Index: LMDZ5/branches/testing/libf/phylmd/calcratqs.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 1707)
@@ -0,0 +1,185 @@
+SUBROUTINE calcratqs(klon,klev,prt_level,lunout,       &
+           iflag_ratqs,iflag_con,iflag_cldcon,pdtphys, &
+           ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
+           ptconv,ptconvth,clwcon0th, rnebcon0th,      &
+           paprs,pplay,q_seri,zqsat,fm_therm,          &
+           ratqs,ratqsc)
+
+implicit none
+
+!========================================================================
+! Computation of ratqs, the width of the subrid scale water distribution
+! (normalized by the mean value)
+! Various options controled by flags iflag_con and iflag_ratqs
+! F Hourdin 2012/12/06
+!========================================================================
+
+! Declarations
+
+! Input
+integer,intent(in) :: klon,klev,prt_level,lunout
+integer,intent(in) :: iflag_con,iflag_cldcon,iflag_ratqs
+real,intent(in) :: pdtphys,ratqsbas,ratqshaut,fact_cldcon,tau_ratqs
+real, dimension(klon,klev+1),intent(in) :: paprs
+real, dimension(klon,klev),intent(in) :: pplay,q_seri,zqsat,fm_therm
+logical, dimension(klon,klev),intent(in) :: ptconv
+real, dimension(klon,klev),intent(in) :: rnebcon0th,clwcon0th
+
+! Output
+real, dimension(klon,klev),intent(inout) :: ratqs,ratqsc
+logical, dimension(klon,klev),intent(inout) :: ptconvth
+
+! local
+integer i,k
+real, dimension(klon,klev) :: ratqss
+real facteur,zfratqs1,zfratqs2
+
+!-------------------------------------------------------------------------
+!  Caclul des ratqs
+!-------------------------------------------------------------------------
+
+!      print*,'calcul des ratqs'
+!   ratqs convectifs a l'ancienne en fonction de q(z=0)-q / q
+!   ----------------
+!   on ecrase le tableau ratqsc calcule par clouds_gno
+      if (iflag_cldcon.eq.1) then
+         do k=1,klev
+         do i=1,klon
+            if(ptconv(i,k)) then
+              ratqsc(i,k)=ratqsbas &
+              +fact_cldcon*(q_seri(i,1)-q_seri(i,k))/q_seri(i,k)
+            else
+               ratqsc(i,k)=0.
+            endif
+         enddo
+         enddo
+
+!-----------------------------------------------------------------------
+!  par nversion de la fonction log normale
+!-----------------------------------------------------------------------
+      else if (iflag_cldcon.eq.4) then
+         ptconvth(:,:)=.false.
+         ratqsc(:,:)=0.
+         if(prt_level.ge.9) print*,'avant clouds_gno thermique'
+         call clouds_gno &
+         (klon,klev,q_seri,zqsat,clwcon0th,ptconvth,ratqsc,rnebcon0th)
+         if(prt_level.ge.9) print*,' CLOUDS_GNO OK'
+       
+       endif
+
+!   ratqs stables
+!   -------------
+
+      if (iflag_ratqs.eq.0) then
+
+! Le cas iflag_ratqs=0 correspond a la version IPCC 2005 du modele.
+         do k=1,klev
+            do i=1, klon
+               ratqss(i,k)=ratqsbas+(ratqshaut-ratqsbas)* &
+               min((paprs(i,1)-pplay(i,k))/(paprs(i,1)-30000.),1.) 
+            enddo 
+         enddo
+
+! Pour iflag_ratqs=1 ou 2, le ratqs est constant au dessus de 
+! 300 hPa (ratqshaut), varie lineariement en fonction de la pression
+! entre 600 et 300 hPa et est soit constant (ratqsbas) pour iflag_ratqs=1
+! soit lineaire (entre 0 a la surface et ratqsbas) pour iflag_ratqs=2
+! Il s'agit de differents tests dans la phase de reglage du modele
+! avec thermiques.
+
+      else if (iflag_ratqs.eq.1) then
+
+         do k=1,klev
+            do i=1, klon
+               if (pplay(i,k).ge.60000.) then
+                  ratqss(i,k)=ratqsbas
+               else if ((pplay(i,k).ge.30000.).and.(pplay(i,k).lt.60000.)) then
+                  ratqss(i,k)=ratqsbas+(ratqshaut-ratqsbas)*(60000.-pplay(i,k))/(60000.-30000.)
+               else
+                  ratqss(i,k)=ratqshaut
+               endif
+            enddo
+         enddo
+
+      else if (iflag_ratqs.eq.2) then
+
+         do k=1,klev
+            do i=1, klon
+               if (pplay(i,k).ge.60000.) then
+                  ratqss(i,k)=ratqsbas*(paprs(i,1)-pplay(i,k))/(paprs(i,1)-60000.)
+               else if ((pplay(i,k).ge.30000.).and.(pplay(i,k).lt.60000.)) then
+                    ratqss(i,k)=ratqsbas+(ratqshaut-ratqsbas)*(60000.-pplay(i,k))/(60000.-30000.)
+               else
+                    ratqss(i,k)=ratqshaut
+               endif
+            enddo
+         enddo
+
+      else if (iflag_ratqs==3) then
+         do k=1,klev
+           ratqss(:,k)=ratqsbas+(ratqshaut-ratqsbas) &
+           *min( ((paprs(:,1)-pplay(:,k))/70000.)**2 , 1. )
+         enddo
+
+      else if (iflag_ratqs==4) then
+         do k=1,klev
+           ratqss(:,k)=ratqsbas+0.5*(ratqshaut-ratqsbas) &
+           *( tanh( (50000.-pplay(:,k))/20000.) + 1.)
+         enddo
+
+      endif
+
+
+
+
+!  ratqs final
+!  -----------
+
+      if (iflag_cldcon.eq.1 .or.iflag_cldcon.eq.2.or.iflag_cldcon.eq.4) then
+
+! On ajoute une constante au ratqsc*2 pour tenir compte de 
+! fluctuations turbulentes de petite echelle
+
+         do k=1,klev
+            do i=1,klon
+               if ((fm_therm(i,k).gt.1.e-10)) then
+                  ratqsc(i,k)=sqrt(ratqsc(i,k)**2+0.05**2)
+               endif
+            enddo
+         enddo
+
+!   les ratqs sont une combinaison de ratqss et ratqsc
+       if(prt_level.ge.9) write(lunout,*)'PHYLMD NOUVEAU TAU_RATQS ',tau_ratqs
+
+         if (tau_ratqs>1.e-10) then
+            facteur=exp(-pdtphys/tau_ratqs)
+         else
+            facteur=0.
+         endif
+         ratqs(:,:)=ratqsc(:,:)*(1.-facteur)+ratqs(:,:)*facteur
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! FH 22/09/2009
+! La ligne ci-dessous faisait osciller le modele et donnait une solution
+! assymptotique bidon et dépendant fortement du pas de temps.
+!        ratqs(:,:)=sqrt(ratqs(:,:)**2+ratqss(:,:)**2)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+         ratqs(:,:)=max(ratqs(:,:),ratqss(:,:))
+      else if (iflag_cldcon<=6) then
+!   on ne prend que le ratqs stable pour fisrtilp
+         ratqs(:,:)=ratqss(:,:)
+      else
+          zfratqs1=exp(-pdtphys/10800.)
+          zfratqs2=exp(-pdtphys/10800.)
+          do k=1,klev
+             do i=1,klon
+                if (ratqsc(i,k).gt.1.e-10) then
+                   ratqs(i,k)=ratqs(i,k)*zfratqs2+(iflag_cldcon/100.)*ratqsc(i,k)*(1.-zfratqs2)
+                endif
+                ratqs(i,k)=min(ratqs(i,k)*zfratqs1+ratqss(i,k)*(1.-zfratqs1),0.5)
+             enddo
+          enddo
+      endif
+
+
+return
+end
Index: LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h	(revision 1669)
+++ LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h	(revision 1707)
@@ -2,6 +2,13 @@
 c $Header$
 c
-c
 cIM on initialise les variables 
+c
+        missing_val=nf90_fill_real
+c
+cIM freq_moyNMC = frequences auxquelles on moyenne les champs accumules 
+cIM               sur les niveaux de pression standard du NMC
+      DO n=1, nout
+       freq_moyNMC(n)=freq_outNMC(n)/freq_calNMC(n)
+      ENDDO
 c
         CALL ini_undefSTD(itap,freq_outNMC)
@@ -157,2 +164,80 @@
      $     lwup,LWup200)
 c
+      twriteSTD(:,:,1)=tsumSTD(:,:,1)
+      qwriteSTD(:,:,1)=qsumSTD(:,:,1)
+      rhwriteSTD(:,:,1)=rhsumSTD(:,:,1)
+      phiwriteSTD(:,:,1)=phisumSTD(:,:,1)
+      uwriteSTD(:,:,1)=usumSTD(:,:,1)
+      vwriteSTD(:,:,1)=vsumSTD(:,:,1)
+      wwriteSTD(:,:,1)=wsumSTD(:,:,1)
+
+      twriteSTD(:,:,2)=tsumSTD(:,:,2)
+      qwriteSTD(:,:,2)=qsumSTD(:,:,2)
+      rhwriteSTD(:,:,2)=rhsumSTD(:,:,2)
+      phiwriteSTD(:,:,2)=phisumSTD(:,:,2)
+      uwriteSTD(:,:,2)=usumSTD(:,:,2)
+      vwriteSTD(:,:,2)=vsumSTD(:,:,2)
+      wwriteSTD(:,:,2)=wsumSTD(:,:,2)
+
+      twriteSTD(:,:,3)=tlevSTD(:,:)
+      qwriteSTD(:,:,3)=qlevSTD(:,:)
+      rhwriteSTD(:,:,3)=rhlevSTD(:,:)
+      phiwriteSTD(:,:,3)=philevSTD(:,:)
+      uwriteSTD(:,:,3)=ulevSTD(:,:)
+      vwriteSTD(:,:,3)=vlevSTD(:,:)
+      wwriteSTD(:,:,3)=wlevSTD(:,:)
+
+      twriteSTD(:,:,4)=tlevSTD(:,:)
+      qwriteSTD(:,:,4)=qlevSTD(:,:)
+      rhwriteSTD(:,:,4)=rhlevSTD(:,:)
+      phiwriteSTD(:,:,4)=philevSTD(:,:)
+      uwriteSTD(:,:,4)=ulevSTD(:,:)
+      vwriteSTD(:,:,4)=vlevSTD(:,:)
+      wwriteSTD(:,:,4)=wlevSTD(:,:)
+c
+cIM initialisation 5eme fichier de sortie 
+      twriteSTD(:,:,5)=tlevSTD(:,:)
+      qwriteSTD(:,:,5)=qlevSTD(:,:)
+      rhwriteSTD(:,:,5)=rhlevSTD(:,:)
+      phiwriteSTD(:,:,5)=philevSTD(:,:)
+      uwriteSTD(:,:,5)=ulevSTD(:,:)
+      vwriteSTD(:,:,5)=vlevSTD(:,:)
+      wwriteSTD(:,:,5)=wlevSTD(:,:)
+c
+cIM initialisation 6eme fichier de sortie 
+      twriteSTD(:,:,6)=tlevSTD(:,:)
+      qwriteSTD(:,:,6)=qlevSTD(:,:)
+      rhwriteSTD(:,:,6)=rhlevSTD(:,:)
+      phiwriteSTD(:,:,6)=philevSTD(:,:)
+      uwriteSTD(:,:,6)=ulevSTD(:,:)
+      vwriteSTD(:,:,6)=vlevSTD(:,:)
+      wwriteSTD(:,:,6)=wlevSTD(:,:)
+cIM for NMC files
+      DO n=1, nlevSTD3
+       DO k=1, nlevSTD
+        if(rlevSTD3(n).EQ.rlevSTD(k)) THEN
+         twriteSTD3(:,n)=tlevSTD(:,k)
+         qwriteSTD3(:,n)=qlevSTD(:,k)
+         rhwriteSTD3(:,n)=rhlevSTD(:,k)
+         phiwriteSTD3(:,n)=philevSTD(:,k)
+         uwriteSTD3(:,n)=ulevSTD(:,k)
+         vwriteSTD3(:,n)=vlevSTD(:,k)
+         wwriteSTD3(:,n)=wlevSTD(:,k)
+        endif !rlevSTD3(n).EQ.rlevSTD(k)
+       ENDDO 
+      ENDDO 
+c
+      DO n=1, nlevSTD8
+       DO k=1, nlevSTD
+        if(rlevSTD8(n).EQ.rlevSTD(k)) THEN
+         tnondefSTD8(:,n)=tnondef(:,k,2)
+         twriteSTD8(:,n)=tsumSTD(:,k,2)
+         qwriteSTD8(:,n)=qsumSTD(:,k,2)
+         rhwriteSTD8(:,n)=rhsumSTD(:,k,2)
+         phiwriteSTD8(:,n)=phisumSTD(:,k,2)
+         uwriteSTD8(:,n)=usumSTD(:,k,2)
+         vwriteSTD8(:,n)=vsumSTD(:,k,2)
+         wwriteSTD8(:,n)=wsumSTD(:,k,2)
+        endif !rlevSTD8(n).EQ.rlevSTD(k)
+       ENDDO 
+      ENDDO 
Index: LMDZ5/branches/testing/libf/phylmd/cfmip_point_locations.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cfmip_point_locations.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cfmip_point_locations.F90	(revision 1707)
@@ -0,0 +1,121 @@
+MODULE cfmip_point_locations
+  IMPLICIT NONE
+
+CONTAINS
+
+ SUBROUTINE read_CFMIP_point_locations(npCFMIP, tab, lonCFMIP, latCFMIP)
+  IMPLICIT none
+  INTEGER :: npCFMIP
+  REAL, DIMENSION(npCFMIP) :: lonCFMIP, latCFMIP
+  INTEGER :: tab(npCFMIP), np
+
+  WRITE(*,*) 'npCFMIP=',npCFMIP
+! OPEN(20, file="pointlocations.txt",status='old')
+  OPEN(20, file="pointlocations.txt",status='old',err=999)
+  OPEN(21, file="pointlocations_lon180.txt")
+  np=1
+10 READ(20,*) tab(np), lonCFMIP(np), latCFMIP(np)
+!!! passage de 0-360 a -180/180
+   IF (lonCFMIP(np).GT.180.) THEN
+    lonCFMIP(np)=lonCFMIP(np)-360.
+   ENDIF 
+   WRITE(21,*) np, lonCFMIP(np), latCFMIP(np)
+   np=np+1
+   IF(np.LE.npCFMIP) THEN 
+    GOTO 10
+   ENDIF
+   CLOSE(20)
+   CLOSE(21)
+999 RETURN
+ END SUBROUTINE read_CFMIP_point_locations
+
+ SUBROUTINE LMDZ_CFMIP_point_locations(npCFMIP, lonCFMIP, latCFMIP, &
+  tabijGCM, lonGCM, latGCM, ipt, jpt)
+  USE dimphy
+  USE iophy
+  USE mod_grid_phy_lmdz
+
+  IMPLICIT none 
+#include "dimensions.h"
+  INTEGER :: npCFMIP
+  REAL, DIMENSION(npCFMIP) :: lonCFMIP, latCFMIP
+  INTEGER :: i, j, np, ip
+  INTEGER, DIMENSION(npCFMIP) :: ipt, jpt 
+  REAL :: dlon1, dlon2
+  REAL :: dlat1, dlat2
+  REAL, DIMENSION(iim+1) :: lon
+  INTEGER, DIMENSION(npCFMIP) :: tabijGCM
+  REAL, DIMENSION(npCFMIP) :: lonGCM, latGCM
+
+  lon(1:iim)=io_lon(:)
+  lon(iim+1)=-1*lon(1)
+  OPEN(22, file="LMDZ_pointsCFMIP.txt")
+  DO np=1, npCFMIP
+  DO i=1, iim
+!
+! PRINT*,'IM np i lonCF lonGCM lonGCM+1',np,i,lonCFMIP(np),lon(i), &
+!  lon(i+1)
+!
+   IF(lonCFMIP(np).GE.lon(i).AND.lonCFMIP(np).LT.lon(i+1)) THEN
+    dlon1 = abs (lonCFMIP(np) - lon(i))
+    dlon2 = abs (lonCFMIP(np) - lon(i+1))
+    IF (dlon1.LE.dlon2) THEN
+     ipt(np)=i
+    ELSE
+     ipt(np)=i+1
+    ENDIF
+   ENDIF
+  END DO
+  END DO
+!
+   np=1
+30 j=1
+40 IF(latCFMIP(np).LE.io_lat(j).AND.latCFMIP(np).GE.io_lat(j+1)) THEN
+    dlat1 = abs (latCFMIP(np) - io_lat(j))
+    dlat2 = abs (latCFMIP(np) - io_lat(j+1))
+    IF (dlat1.LE.dlat2) THEN
+     jpt(np)=j
+    ELSE
+     jpt(np)=j+1
+    ENDIF
+    np=np+1
+    IF(np.LE.npCFMIP) THEN
+     GOTO 30
+    ENDIF 
+   ELSE
+    j=j+1
+    IF(j.LE.jjm) THEN 
+     GOTO 40
+    ENDIF
+   ENDIF
+
+  DO np=1, npCFMIP
+   WRITE(22,*) lon(ipt(np)), io_lat(jpt(np))
+  ENDDO
+  CLOSE(22)
+
+  OPEN(23, file="pointsCFMIPvsLMDZ.txt")
+    DO ip=1, npCFMIP
+     lonGCM(ip)=lon(ipt(ip))
+     latGCM(ip)=io_lat(jpt(ip))
+     if(jpt(ip).GE.2.AND.jpt(ip).LE.jjm) THEN     
+      tabijGCM(ip)=1+(jpt(ip)-2)*iim+ipt(ip)
+     else if(jpt(ip).EQ.1) THEN
+      tabijGCM(ip)=1
+     else if(jpt(ip).EQ.jjm+1) THEN
+      tabijGCM(ip)=klon_glo
+     else 
+      print*,'ip jpt tabijGCM',ip,jpt(ip),tabijGCM(ip)
+     endif
+!    PRINT*,'CFMIP ip lon lat tabijGCM',ip,lonGCM(ip),latGCM(ip),tabijGCM(ip)
+    ENDDO
+    DO ip=1, npCFMIP
+     if(lonGCM(ip).EQ.io_lon(1)) lonGCM(ip)=360.+lonGCM(ip)
+    ENDDO
+   DO i=1, npCFMIP
+    WRITE(23,*) i, lonCFMIP(i), latCFMIP(i), lonGCM(i), latGCM(i), tabijGCM(i)
+   ENDDO
+   CLOSE(23)
+ END SUBROUTINE LMDZ_CFMIP_point_locations 
+
+END MODULE CFMIP_point_locations
Index: LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 1669)
+++ LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 1707)
@@ -12,5 +12,5 @@
 
   SUBROUTINE change_srf_frac(itime, dtime, jour, &
-       pctsrf, alb1, alb2, tsurf, u10m, v10m, pbl_tke)
+       pctsrf, alb1, alb2, tsurf, ustar, u10m, v10m, pbl_tke)
 !
 ! This subroutine is called from physiq.F at each timestep. 
@@ -46,4 +46,5 @@
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb2   ! albedo second interval in SW spektrum
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: tsurf
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: ustar
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: u10m
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: v10m
@@ -150,5 +151,5 @@
 ! 
 !****************************************************************************************
-       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, u10m, v10m, pbl_tke)
+       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, ustar, u10m, v10m, pbl_tke)
 
     ELSE
